/*

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                Arlips compiler v. 3.1           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

File constant.h, global constants
April 2006

Copyright (C) 2006 Emilio Vivancos Rubio

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                              Contact                          %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Author:              Emilio Vivancos Rubio  vivancos@dsic.upv.es
Developer Arlips v2: Mario Gonzlez Gimnez mgonzale@dsic.upv.es
Developer Arlips v3: Carlos Garca Montoro  cargarcia@dsic.upv.es

Departamento de Sistemas Informticos y Computacin
Universidad Politcnica de Valencia
Camino de Vera s/n
46022 Valencia
Spain

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

*/

#ifndef _CONSTANTES_
#define _CONSTANTES_

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define TRUE 1
#define FALSE 0


/* para reservar espacio de memoria, se hace en funcion del tamao de */
/* un tipo proporcionado por el lenguaje, que se tomara como referencia */
/* esto se hace en el '#define...TIPOBASE', pudiendolo cambiar a nuestro*/
/* gusto, el tamao del tipo viene dado en el 'define TAM' */

#define TIPOBASE float
#define TAM  sizeof(TIPOBASE)
/* #define NULL 0  */  /* puntero nulo */
#define PTIF (int(*)())

/** Constantes **/

#define num_pal_reser 58  /* N. de palabras reservadas */
#define long_ident   30  /* longitud maxima de un identificador */
#define long_linea   121  /* longitud maxima de una linea del programa fuente */
#define num_men_error 100
#define HASH_SIZE 50
#define num_reglas 20 /* numero maximo de reglas para acotar los conjuntos */
                      /* del analisis temporal */
#define num_variables 20 /* numero maximo de variables que se pueden usar */        
#define max_cadena_comillas 255 //longitud max de cadenas para print o ficheros
#define max_pila_f 20 //Mximo de includes+imports
#define max_f_ext 25 //Mximo de ficheros externos

#define PRECISION_FLOAT 32

#endif
