/*

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                Arlips compiler v. 3.1           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

File es.c, files
April 2006

Copyright (C) 2006 Emilio Vivancos Rubio

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                              Contact                          %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Author:              Emilio Vivancos Rubio  vivancos@dsic.upv.es
Developer Arlips v2: Mario Gonzlez Gimnez mgonzale@dsic.upv.es
Developer Arlips v3: Carlos Garca Montoro  cargarcia@dsic.upv.es

Departamento de Sistemas Informticos y Computacin
Universidad Politcnica de Valencia
Camino de Vera s/n
46022 Valencia
Spain

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

*/




#include <values.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "es.h"

#define TRUE 1
#define FALSE 0
#define SEEK_CUR 1 /* est definido en io.h */

int hsal_est,ala;
/****************************************/

char eof(f)
int f;
{
   char c[2];
   char retorno;

   if(read(f,c,1)<1) retorno=TRUE;
   else{
	 retorno=FALSE;
	 lseek(f,-1L,SEEK_CUR);
       }
   return(retorno);
}

 
char eoln(f)
int f;
{
  char c[2];
  char retorno;

  if(read(f,c,1)==-1) printf("error\n");
  if(c[0]==10)
      {
	/* he encontrado un fin de linea */

	retorno=TRUE;
       }
   else retorno=FALSE;
   lseek(f,-1L,SEEK_CUR);
   return(retorno);

}

int abrir_fichero_lectura(char * fich) {
  //CGM: Esta funcin tiene que devolver un entero, por tanto, o se hace un cast
  //o no se pueder reescribir para que use abre_fichero.

  int f;
  char *ruta;
  extern char *input_path;

  if (input_path != NULL) {
    ruta = (char *)malloc(strlen(input_path) + strlen(fich) +2); //Para el "/" y el '\0'
    strcpy(ruta, input_path);
    if (input_path[strlen(input_path) - 1] != '/') //Si no se ha escrito la "/" que indica directorio, se pone
      strcat(ruta, "/");
    strcat(ruta, fich);
  }
  else {
    ruta = fich;
  }

  if((f = open(ruta, 0 /*O_RDONLY*/)) == -1){
    menerror_1(121);
  }
  
  if (input_path != NULL)
    free(ruta);

  return(f);
}

FILE *abrir_fichero_escritura(char * fich) { 
  //CGM: Mantenida por compatibilidad

  extern char *output_path;

  return (abre_fichero(output_path, fich, "w"));
}

FILE *abre_fichero(char *dir, char *fich, char *modo) {

  FILE *f;
  char *ruta;

  if (dir != NULL) {
    ruta = (char *)malloc(strlen(dir) + strlen(fich) +2); //Para el "/" de directorio y el '\0' de fin de cadena
    strcpy(ruta, dir);
    if (dir[strlen(dir) - 1] != '/') //Si no se ha escrito la "/" que indica directorio, se pone
      strcat(ruta, "/");    
    strcat(ruta, fich);
  }
  else {
    ruta = fich;
  }

  if ((f = fopen(ruta, modo)) == NULL) {
    menerror_1(121);
  }
  
  if (dir != NULL)
    free(ruta);
  
  return(f);
}


void cierra_fichero(FILE *f) {

   if (fclose(f)) {
      printf("Error al cerrar el fichero\n");
   }
}


